Skip to content
Snippets Groups Projects
Commit f4b7ae95 authored by Martin André's avatar Martin André
Browse files

Check for nova DB availability in dependent containers

When nova-api start and the nova database hasn't yet been created, it
would create it itself, preventing the migration in nova-conductor to
run and making it unable to start. This commit ensures that nova-api
container will not try to steal nova-conductor's job of creating the
nova database.

Nova-scheduler reacts differently to the missing database and simply
exits with a backtrace. This commit also prevents nova-scheduler to
start when the nova database cannot be found.

Change-Id: Ib6f7521151815faa7a26ec1d170df5a1cdb7fd63
Related-Bug: #1335804
parent 91ca8d4b
No related branches found
No related tags found
No related merge requests found
......@@ -56,12 +56,14 @@ check_for_neutron() {
}
# Exit unless we receive a successful response from the database server.
# Optionally takes a database name to check for. Defaults to 'mysql'.
check_for_db() {
local database=${1:-mysql}
check_required_vars MARIADB_SERVICE_HOST DB_ROOT_PASSWORD
mysql -h ${MARIADB_SERVICE_HOST} -u root -p"${DB_ROOT_PASSWORD}" \
-e "select 1" mysql > /dev/null 2>&1 || {
echo "ERROR: database is not available @ $MARIADB_SERVICE_HOST" >&2
-e "select 1" $database > /dev/null 2>&1 || {
echo "ERROR: database $database is not available @ $MARIADB_SERVICE_HOST" >&2
exit 1
}
......
......@@ -11,7 +11,6 @@
: ${RABBIT_PASSWORD:=guest}
: ${NETWORK_MANAGER:=nova}
check_for_db
check_required_vars KEYSTONE_ADMIN_TOKEN NOVA_DB_PASSWORD \
RABBITMQ_SERVICE_HOST GLANCE_API_SERVICE_HOST \
KEYSTONE_PUBLIC_SERVICE_HOST PUBLIC_IP
......
......@@ -7,8 +7,9 @@ set -e
check_required_vars KEYSTONE_ADMIN_TOKEN KEYSTONE_ADMIN_SERVICE_HOST \
NOVA_KEYSTONE_USER NOVA_KEYSTONE_PASSWORD \
ADMIN_TENANT_NAME NOVA_API_SERVICE_HOST \
NOVA_EC2_API_SERVICE_HOST PUBLIC_IP
NOVA_EC2_API_SERVICE_HOST PUBLIC_IP NOVA_DB_NAME
check_for_keystone
check_for_db $NOVA_DB_NAME
export SERVICE_TOKEN="${KEYSTONE_ADMIN_TOKEN}"
export SERVICE_ENDPOINT="http://${KEYSTONE_ADMIN_SERVICE_HOST}:35357/v2.0"
......
......@@ -4,4 +4,7 @@ set -e
. /opt/kolla/config-nova.sh
check_required_vars NOVA_DB_NAME
check_for_db $NOVA_DB_NAME
exec /usr/bin/nova-scheduler
0% Loading or .
You are about to add 0 people to the discussion. Proceed with caution.
Finish editing this message first!
Please register or to comment